<?php
/*
Plugin Name: AllConsuming
Plugin URI: http://www.ali-hassan.net/?p=115
Description: Adds an <a href="http://allconsuming.net">allconsuming</a> list to the sidebar.
Author: Ali Hassan, Tristan Havelick
Version: 2.1
Author URI: http://ali-hassan.net

	Original Widget by Ali Hassan.

	Completed added by Tristan Havelick
	http://www.tristanhavelick.com/
	http://www.tristanhavelick.com/upgrade-of-allconsuming-widget/

	My Widget is released under the GNU General Public License (GPL)
	http://www.gnu.org/licenses/gpl.txt

	This is a WordPress plugin (http://wordpress.org) and widget
	(http://automattic.com/code/widgets/).
*/

// We're putting the plugin's functions in one big function we then
// call at 'plugins_loaded' (add_action() at bottom) to ensure the
// required Sidebar Widget functions are available.
function widget_allconsuming_init() {

	// Check to see required Widget API functions are defined...
	if ( !function_exists('register_sidebar_widget') || !function_exists('register_widget_control') )
		return; // ...and if not, exit gracefully from the script.

	// This function prints the sidebar widget--the cool stuff!
	function widget_allconsuming($args, $number = 1 ) {

		// $args is an array of strings which help your widget
		// conform to the active theme: before_widget, before_title,
		// after_widget, and after_title are the array keys.
		extract($args);

		// Collect our widget's options, or define their defaults.
		$options = get_option('widget_allconsuming');
		$title = empty($options[$number]['title']) ? 'Currently Consuming:' : $options[$number]['title'];
		$text = empty($options[$number]['text']) ? 'Your username' : $options[$number]['text'];
		$numberitems = empty($options[$number]['numberitems']) ? '6' : $options[$number]['numberitems'];
		$tags = empty($options[$number]['tags']) ? 'all' : $options[$number]['tags'];
		$suppressheader = empty($options[$number]['suppressheader']) ? '' : $options[$number]['suppressheader'];

		$shjs = $options[$number]['suppressheader'] ? '?suppress_header=1' : '';
        $completed = $options[$number]['completed'] ? 'completed_' : '';


 		// It's important to use the $before_widget, $before_title,
 		// $after_title and $after_widget variables in your output.
		echo $before_widget;
		echo $before_title . $title . $after_title;
		echo '<script language="javascript" type="text/javascript" src="http://allconsuming.net/person/' . $text . '/' . $completed  . 'js/' . $tags . '/' . $numberitems . $shjs .'"></script>';
		echo '<p class="alignright"><a href="http://allconsuming.net/person/' . $text . '/">More &raquo;</a></p><div style="font-size:1px;margin:0;padding:0;clear:both;"></div>';
		echo $after_widget;
	}

	// This is the function that outputs the form to let users edit
	// the widget's title and so on. It's an optional feature, but
	// we'll use it because we can!
	function widget_allconsuming_control($number) {
		global $wpdb;

		// Collect our widget's options.
		$options = $newoptions = get_option('widget_allconsuming');

		// This is for handing the control form submission.
		if ( $_POST["allconsuming-submit-$number"] ) {
			// Clean up control form submission options
			$newoptions[$number]['title'] = strip_tags(stripslashes($_POST["allconsuming-title-$number"]));
			$newoptions[$number]['text'] = strip_tags(stripslashes($_POST["allconsuming-text-$number"]));
			$newoptions[$number]['numberitems'] = strip_tags(stripslashes($_POST["allconsuming-numberitems-$number"]));
			$newoptions[$number]['tags'] = strip_tags(stripslashes($_POST["allconsuming-tags-$number"]));
			$newoptions[$number]['suppressheader'] = isset($_POST["allconsuming-suppressheader-$number"]);
			$newoptions[$number]['completed'] = isset($_POST["allconsuming-completed-$number"]);
		}

		// If original widget options do not match control form
		// submission options, update them.
		if ( $options != $newoptions ) {
			$options = $newoptions;
			update_option('widget_allconsuming', $options);
		}

		// Format options as valid HTML. Hey, why not. Put the default value in if it's empty, too.
		$title = empty($options[$number]['title']) ? 'Currently Consuming:' : htmlspecialchars($options[$number]['title'], ENT_QUOTES);
		$text = htmlspecialchars($options[$number]['text'], ENT_QUOTES);
		$numberitems = htmlspecialchars($options[$number]['numberitems'], ENT_QUOTES);
		$tags = empty($options[$number]['tags']) ? 'all' : htmlspecialchars($options[$number]['tags'], ENT_QUOTES);

		$sh = $options[$number]['suppressheader'] ? 'checked="checked"' : '';
		$completed_checked = $options[$number]['completed'] ? 'checked="checked"' : '';


// The HTML below is the control form for editing options.
?>
		<div style="text-align:right;">
		<label for="allconsuming-title-<?php echo "$number"; ?>" style="line-height:35px;display:block;">Title: <input type="text" id="allconsuming-title-<?php echo "$number"; ?>" name="allconsuming-title-<?php echo "$number"; ?>" value="<?php echo $title; ?>" /></label>
		<label for="allconsuming-text-<?php echo "$number"; ?>" style="line-height:35px;display:block;">Your username: <input type="text" id="allconsuming-text-<?php echo "$number"; ?>" name="allconsuming-text-<?php echo "$number"; ?>" value="<?php echo $text; ?>" /></label>
		<label for="allconsuming-numberitems-<?php echo "$number"; ?>" style="line-height:35px;display:block;">Number of items: <input type="text" id="allconsuming-numberitems-<?php echo "$number"; ?>" name="allconsuming-numberitems-<?php echo "$number"; ?>" value="<?php echo $numberitems; ?>" /></label>
		<label for="allconsuming-tags-<?php echo "$number"; ?>" style="line-height:35px;display:block;">Tags: <input type="text" id="allconsuming-tags-<?php echo "$number"; ?>" name="allconsuming-tags-<?php echo "$number"; ?>" value="<?php echo $tags; ?>" /></label>
		<label for="allconsuming-suppressheader-<?php echo "$number"; ?>" style="line-height:35px;display:block;">Suppress header: <input style="margin-right:155px;" class="checkbox" type="checkbox" <?php echo $sh; ?> id="allconsuming-suppressheader-<?php echo "$number"; ?>" name="allconsuming-suppressheader-<?php echo "$number"; ?>" /></label>
		<label for="allconsuming-completed-<?php echo "$number"; ?>" style="line-height:35px;display:block;">Completed items: <input style="margin-right:155px;" class="checkbox" type="checkbox" <?php echo $completed_checked; ?> id="allconsuming-completed-<?php echo "$number"; ?>" name="allconsuming-completed-<?php echo "$number"; ?>" /></label>


		<input type="hidden" name="allconsuming-submit-<?php echo "$number"; ?>" id="allconsuming-submit-<?php echo "$number"; ?>" value="1" />
		</div>
	<?php
	// end of widget_allconsuming_control()
	}

function widget_allconsuming_setup() {
	$options = $newoptions = get_option('widget_allconsuming');
	if ( isset($_POST['allconsuming-number-submit']) ) {
		$number = (int) $_POST['allconsuming-number'];
		if ( $number > 9 ) $number = 9;
		if ( $number < 1 ) $number = 1;
		$newoptions['number'] = $number;
	}
	if ( $options != $newoptions ) {
		$options = $newoptions;
		update_option('widget_allconsuming', $options);
		widget_allconsuming_register($options['number']);
	}
}

function widget_allconsuming_page() {
	$options = $newoptions = get_option('widget_allconsuming');
?>
	<div class="wrap">
		<form method="POST">
			<h2>AllConsuming Widgets</h2>
			<p style="line-height: 30px;"><?php _e('How many AllConsuming widgets would you like?'); ?>
			<select id="allconsuming-number" name="allconsuming-number" value="<?php echo $options['number']; ?>">
<?php for ( $i = 1; $i < 10; ++$i ) echo "<option value='$i' ".($options['number']==$i ? "selected='selected'" : '').">$i</option>"; ?>
			</select>
			<span class="submit"><input type="submit" name="allconsuming-number-submit" id="allconsuming-number-submit" value="<?php _e('Save'); ?>" /></span></p>
		</form>
	</div>
<?php
}

function widget_allconsuming_register() {
	$options = get_option('widget_allconsuming');
	$number = $options['number'];
	if ( $number < 1 ) $number = 1;
	if ( $number > 9 ) $number = 9;
	for ($i = 1; $i <= 9; $i++) {
		$name = array('AllConsuming %s', null, $i);
		register_sidebar_widget($name, $i <= $number ? 'widget_allconsuming' : /* unregister */ '', $i);
		register_widget_control($name, $i <= $number ? 'widget_allconsuming_control' : /* unregister */ '', 350, 225, $i);
	}
	add_action('sidebar_admin_setup', 'widget_allconsuming_setup');
	add_action('sidebar_admin_page', 'widget_allconsuming_page');
}

// Delay plugin execution to ensure Dynamic Sidebar has a chance to load first
widget_allconsuming_register();
}

// Tell Dynamic Sidebar about our new widget and its control
add_action('plugins_loaded', 'widget_allconsuming_init');


?>